define(["preact","htm","jquery","uuid","../CollapsiblePanel","kb_common/utils","../Panel","bootstrap","css!./style.css"],((e,t,r,a,s,o,n)=>{
const{Component:i}=e,d=t.bind(e.h);function p(e){if(o.isBlank(e))return""
;const t=o.iso8601ToDate(e)
;return`${["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"][t.getMonth()]} ${t.getDate()}, ${t.getFullYear()}`
}return class extends i{componentDidMount(){r(document).ready((()=>{
r('[data-toggle="tooltip"]').tooltip({delay:{show:500,hide:100}})}))}
renderDataIcon(){
const e=this.props.objectInfo.type,t=this.props.runtime.service("type").parseTypeId(e),r=this.props.runtime.service("type").getIcon({
type:t});return d`
            <div>
                <span className="fa-stack fa-2x">
                    <i className="fa fa-circle fa-stack-2x"
                       style=${{color:r.color}} ></i>
                    <i className=${`fa fa-inverse fa-stack-1x ${r.classes.join(" ")}`}></i>
                </span>
            </div>
            `}renderNarrativeRow(){
if(this.props.workspaceInfo.metadata.narrative_nice_name)return d`
                <tr>
                    <th>In Narrative</th>
                    <td>
                        <a href="${`/narrative/${this.props.workspaceInfo.id}`}" target="_blank">
                            ${this.props.workspaceInfo.metadata.narrative_nice_name}
                        </a>
                    </td>
                </tr>
            `}renderPermalinkRow(){const{protocol:e,host:t}=window.location
;let r=`${e}//${t}/#dataview/${this.props.objectInfo.ref}`
;return this.props.sub&&this.props.sub.subid&&(r+=`?${this.props.sub.sub}&${this.props.sub.subid}`),
d`
            <tr>
                <th>Permalink</th>
                <td>
                    <a href="${r}" target="_parent">
                        ${r}
                    </a>
                </td>
            </tr>
            `}renderVersionRow(){return d`
            <tr>
                <th>Object Version</th>
                <td>${this.props.objectInfo.version||"Latest"}</td>
            </tr>
            `}renderTypeRow(){return d`
            <tr>
                <th>Type</th>
                <td>${this.props.sub&&this.props.sub.sub?`${this.props.sub.sub} in `:""}
                    <a href="${`/#spec/type/${this.props.objectInfo.type}`}" target="_blank">
                        ${this.props.objectInfo.typeName}
                    </a>
                </td>
            </tr>
            `}renderTypeModuleRow(){return d`
            <tr>
                <th>Type Module</th>
                <td>${this.props.sub&&this.props.sub.sub?`${this.props.sub.sub} in `:""}
                    <a href="${`/#spec/module/${this.props.objectInfo.typeModule}`}" target="_blank">
                        ${this.props.objectInfo.typeModule}
                    </a>
                </td>
            </tr>
            `}renderTypeVersionRow(){return d`
            <tr>
                <th>Type Version</th>
                <td>
                    ${this.props.objectInfo.typeMajorVersion}. ${this.props.objectInfo.typeMinorVersion}
                </td>
            </tr>
            `}renderLastUpdatedRow(){return d`
            <tr>
                <th>Last Updated</th>
                <td>${p(this.props.objectInfo.save_date)} by ${" "}
                    <a href="${`/#people/${this.props.objectInfo.saved_by}`}" target="_blank">
                        ${this.props.objectInfo.saved_by}
                    </a>
                </td>
            </tr>
            `}renderSummary(){return d`
                <table className="table">
                    <tbody>
                        ${this.renderTypeRow()}
                        ${this.renderNarrativeRow()}
                        ${this.renderLastUpdatedRow()}
                        ${this.renderPermalinkRow()}
                        ${this.renderButtonsRow()}
                    </tbody>
                </table>
            `}renderHeader(){return d`
            <div className="Overview-header">   
                <div>
                    ${this.renderDataIcon()}
                </div>
                <h3 className="Overview-header-title">
                    ${this.props.sub&&this.props.sub.id?this.props.sub.subid:this.props.objectInfo.name}
                </h3>
            </div>
            `}renderObjectInfo(e){const t=d`
            <table className="table">
                <tbody>
                    ${this.renderVersionRow()}
                    ${this.renderTypeModuleRow()}
                    ${this.renderTypeRow()}
                    ${this.renderTypeVersionRow()}
                    ${this.renderNarrativeRow()}
                    ${this.renderLastUpdatedRow()}
                    ${this.renderPermalinkRow()}
                </tbody>
            </table>
            `;return d`
            <${n} title="Object Info"
                      parentId=${e}>
                ${t}
            <//>
            `}renderMetadataPanel(e){const t=(()=>{
const e=Object.entries(this.props.objectInfo.metadata);if(0===e.length)return d`
                        <p>no metadata for this object</p>
                    `;const t=e.map((([e,t])=>d`
                    <tr>
                        <th>${e}</th>
                        <td>${t}</td>
                    </tr>
                    `));return d`
                <table className="table Overview-metadata-table">
                    <tbody>
                        ${t}
                    </tbody>
                </table>
                `})();return d`
            <${n} title="Metadata"
                      parentId=${e}>
                ${t}
            <//>
            `}renderVersionsPanel(e){const t=(()=>{
if(0===this.props.versions.length)return d`
                        <p>no versions</p>
                    `;const e=this.props.versions.map((e=>d`
                    <tr>
                        <td>
                            <a href=${`/#dataview/${e.wsid}/${e.id}/${e.version}`} target="_parent">
                                v${e.version}
                            </a>
                        </td>
                        <td>
                            Saved on ${p(e.save_date)} by ${" "}
                            <a href="/#people/${e.saved_by}" target="_parent">${e.saved_by}</a>
                        </td>
                    </tr>
                    `));return d`
                <table className="table Overview-metadata-table">
                    <tbody>
                        ${e}
                    </tbody>
                </table>
                `})();return d`
            <${n} title="Versions"
                      parentId=${e}>
                ${t}
            <//>
            `}renderReferencedByPanel(e){const t=(()=>{
if(this.props.too_many_inc_refs)return d`
                        <span>Sorry, there are too many references to this data to display.</span>
                    `;if(!this.props.inc_references)return d`
                        <p>
                            No other data references this data object.
                        </p>
                    `;const e=this.props.inc_references.map((e=>d`
                    <tr>
                        <td>
                            <a href=${`/#dataview/${e.wsid}/${e.id}/${e.version}`} target="_parent">${e.name}</a>
                        </td>
                        <td>
                            <a href=${`/#spec/type/${e.type}`} target="_parent">${e.typeName}</a>
                        </td>
                        <td>
                            ${p(e.save_date)}
                        </td>
                        <td>
                            <a href=${`/#people/${e.saved_by}`} target="_parent">${e.saved_by}</a>
                        </td>
                    </tr>
                    `));return d`
                <table className="table kb-overview-table">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Type</th>
                            <th>Saved</th>
                            <th>By</td>
                        </tr>
                    </thead>
                    <tbody>
                        ${e}
                    </tbody>
                </table>
                `})();return d`
            <${n} title="Referenced by"
                      parentId=${e}>
                ${t}
            <//>
            `}renderReferencesPanel(e){const t=(()=>{
if(this.props.too_many_out_refs)return d`
                        <span>Sorry, there are too many references to this data to display.</span>
                    `;if(!this.props.out_references)return d`
                        <p>
                            No other data references this data object.
                        </p>
                    `;const e=this.props.out_references.map((e=>d`
                    <tr>
                        <td>
                            <a href=${`/#dataview/${e.wsid}/${e.id}/${e.version}`} target="_parent">${e.name}</a>
                        </td>
                        <td>
                            <a href=${`/#spec/type/${e.type}`} target="_parent">${e.typeName}</a>
                        </td>
                        <td>
                            ${p(e.save_date)}
                        </td>
                        <td>
                            <a href=${`/#people/${e.saved_by}`} target="_parent">${e.saved_by}</a>
                        </td>
                    </tr>
                    `));return d`
                <table className="table kb-overview-table">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Type</th>
                            <th>Saved</th>
                            <th>By</td>
                        </tr>
                    </thead>
                    <tbody>
                        ${e}
                    </tbody>
                </table>
                `})();return d`
            <${n} title="References"
                      parentId=${e}>
                ${t}
            <//>
            `}handleCopyButtonClick(){
this.props.runtime.send("copyWidget","toggle")}renderButtonsRow(){return d`
            <tr>
                <th></th>
                <td>
                    <button className="btn btn-default"
                            data-toggle="tooltip"
                            data-placement="bottom"
                            title="Opens (and closes) a panel with which you can copy this data object to a Narrative",
                            onClick=${this.handleCopyButtonClick.bind(this)}>
                        Copy
                    </button>
                    ${" "}
                    <a className="btn btn-default"
                            data-toggle="tooltip"
                            data-placement="bottom"
                            title="View the actual JSON for this object"
                            href=${`/#jsonview/${this.props.objectInfo.ref}`}
                            target="_parent">
                        JSON View
                    </a>
                </td>
            </tr>
            `}renderOverview(){const e=`panel-${new a(4).format()}`;return d`
            <div className="row">
                <div className="col-sm-6">
                    ${this.renderHeader()}
                    ${this.renderSummary()}
                </div>
                <div className="col-sm-6">
                    <div className="panel-group"
                         id=${e}
                         role="tablist"
                         aria-multiselectable="true">
                        ${this.renderObjectInfo(e)}
                        ${this.renderMetadataPanel(e)}
                        ${this.renderVersionsPanel(e)}
                        ${this.renderReferencedByPanel(e)}
                        ${this.renderReferencesPanel(e)}
                    </div>
                </div>
            </div>
            `}render(){return d`
                <${s} collapsed=${!1}
                                     title="Overview">
                    ${this.renderOverview()}
                <//>
            `}}}));