define(["jquery","kb_service/client/workspace","kb_service/client/fba","kb_common/jsonRpc/dynamicServiceClient","widgets/modeling/KBModeling","widgets/modeling/kbasePathways"],(function(e,a,i,t,n){
"use strict";n.prototype.KBaseFBA_FBAModel=function(i){var n=this
;this.modeltabs=i,
this.runtime=i.runtime,this.workspaceClient=new a(this.runtime.config("services.workspace.url"),{
token:this.runtime.service("session").getAuthToken()
}),this.setMetadata=function(a){const[i,t,n,s,l,o,d,m,,,r]=a
;this.workspace=m,this.objName=t,this.overview={wsid:m+"/"+t,
ref:[d,i,l].join("/"),ws:m,obj_name:t,objecttype:n,owner:o,instance:l,moddate:s
},"Name"in r?(this.usermeta={name:r.Name,source:r.Source+"/"+r["Source ID"],
genome:r.Genome,modeltype:r.Type,numreactions:r["Number reactions"],
numcompounds:r["Number compounds"],numcompartments:r["Number compartments"],
numbiomass:r["Number biomasses"],numgapfills:r["Number gapfills"]
},e.extend(this.overview,this.usermeta)):this.usermeta={}},this.cmpnamehash={
c:"Cytosol",p:"Periplasm",g:"Golgi apparatus",e:"Extracellular",
r:"Endoplasmic reticulum",l:"Lysosome",n:"Nucleus",d:"Plastid",m:"Mitochondria",
x:"Peroxisome",v:"Vacuole",w:"Cell wall"},this.tabList=[{key:"overview",
name:"Overview",type:"verticaltbl",rows:[{label:"Name",key:"name"},{label:"ID",
key:"wsid"},{label:"Object type",key:"objecttype",type:"typelink"},{
label:"Owner",key:"owner"},{label:"Version",key:"instance"},{label:"Mod-date",
key:"moddate"},{label:"Source",key:"source"},{label:"Genome",key:"genome",
type:"wstype"},{label:"Model type",key:"modeltype"},{label:"Number reactions",
key:"numreactions"},{label:"Number compounds",key:"numcompounds"},{
label:"Number compartments",key:"numcompartments"},{label:"Number biomass",
key:"numbiomass"},{label:"Number gapfills",key:"numgapfills"}]},{
key:"modelreactions",name:"Reactions",type:"dataTable",columns:[{
label:"Reaction",type:"tabLink",linkformat:"dispIDCompart",key:"id",
method:"ReactionTab",width:"15%"},{label:"Name",key:"name"},{label:"Equation",
key:"equation",type:"tabLink",linkformat:"linkequation"},{label:"Genes",
key:"genes",type:"tabLinkArray",method:"GeneTab"},{label:"Gapfilling",
key:"gapfillingstring"}]},{key:"modelcompounds",name:"Compounds",
type:"dataTable",columns:[{label:"Compound",key:"id",type:"tabLink",
linkformat:"dispIDCompart",method:"CompoundTab",width:"15%"},{label:"Name",
key:"name"},{label:"Formula",key:"formula"},{label:"Charge",key:"charge"},{
label:"Compartment",key:"cmpkbid",type:"tabLink",method:"CompartmentTab",
linkformat:"dispID"}]},{key:"modelgenes",name:"Genes",type:"dataTable",
columns:[{label:"Gene",key:"id",type:"tabLink",method:"GeneTab"},{
label:"Reactions",key:"reactions",type:"tabLinkArray",method:"ReactionTab"}]},{
key:"modelcompartments",name:"Compartments",type:"dataTable",columns:[{
label:"Compartment",key:"id",type:"tabLink",method:"CompartmentTab",
linkformat:"dispID"},{label:"Name",key:"name"},{label:"pH",key:"pH"},{
label:"Potential",key:"potential"}]},{key:"biomasscpds",name:"Biomass",
type:"dataTable",columns:[{label:"Biomass",key:"biomass",type:"tabLink",
method:"BiomassTab",linkformat:"dispID"},{label:"Compound",key:"id",
type:"tabLink",linkformat:"dispIDCompart",method:"CompoundTab"},{label:"Name",
key:"name"},{label:"Coefficient",key:"coefficient"},{label:"Compartment",
key:"cmpkbid",type:"tabLink",linkformat:"dispID",method:"CompartmentTab"}]},{
key:"gapfillings",name:"Gapfilling",type:"dataTable",columns:[{label:"Gapfill",
key:"simpid"},{label:"Integrated",key:"integrated"},{label:"Media",
key:"media_ref",linkformat:"dispWSRef",type:"wstype",wstype:"KBaseFBA.Media"}]
},{name:"Pathways",widget:"kbasePathways",getParams:function(){return{
runtime:n.runtime,models:[n.data]}}}],this.ReactionTab=function(e){
var a=n.rxnhash[e.id],i=[{label:"Reaction",data:a.dispid},{label:"Name",
data:a.name}];return"pathway"in a&&i.push({label:"Pathway",data:a.pathway
}),"reference"in a&&i.push({label:"Reference",data:a.reference}),i.push({
label:"Compartment",
data:n.cmphash[a.cmpkbid].name+" "+n.cmphash[a.cmpkbid].compartmentIndex},{
label:"Equation",data:a.equation,type:"pictureEquation"},{label:"GPR",data:a.gpr
}),"rxn00000"!==a.rxnkbid?new t({
url:this.runtime.config("services.service_wizard.url"),
token:this.runtime.service("session").getAuthToken(),module:"BiochemistryAPI"
}).callFunc("get_reactions",[{reactions:[a.rxnkbid],biochemistry:n.biochem,
biochemistry_workspace:"kbase"}]).spread((function(e){"deltaG"in e[0]&&i.push({
label:"Delta G",data:e[0].deltaG+" ("+e[0].deltaGErr+") kcal/mol"
}),e[0].enzymes&&i.push({label:"Enzymes",data:e[0].enzymes.join(", ")})
;for(var a={},t=[],n=0;n<e[0].aliases.length;n++)e[0].aliases[n]in a||(t.push(e[0].aliases[n]),
a[e[0].aliases[n]]=1);return i.push({label:"Aliases",data:t.join(", ")}),i})):i
},this.GeneTab=function(e){var a;return n.modelgenes.forEach((function(i){
i.id===e.id&&(a=[{label:"ID",data:i.id},{label:"Reactions",data:i.reactions,
type:"tabLinkArray",method:"ReactionTab"}])})),a},this.CompoundTab=function(e){
const a=n.cpdhash[e.id],i=a.id.split("_")[0];var s=[{label:"Compound",
data:a.dispid},{label:"Image",
data:`<img src="https://minedatabase.mcs.anl.gov/compound_images/ModelSEED//${i}.png" style="height:300px !important;">`
},{label:"Name",data:a.name},{label:"Formula",data:a.formula},{label:"InChIKey",
data:a.inchikey},{label:"SMILES",data:a.smiles},{label:"Charge",data:a.charge},{
label:"Compartment",
data:n.cmphash[a.cmpkbid].name+" "+n.cmphash[a.cmpkbid].compartmentIndex
}],l=new t({url:this.runtime.config("services.service_wizard.url"),
token:this.runtime.service("session").getAuthToken(),module:"BiochemistryAPI"})
;return a.smiles&&"cpd00000"==a.cpdkbid?l.callFunc("depict_compounds",[{
structures:[a.smiles]}]).then((function(e){return s[1]={label:"Image",data:e[0]
},s})):"cpd00000"!==a.cpdkbid?l.callFunc("get_compounds",[{
compounds:[a.cpdkbid],biochemistry:n.biochem,biochemistry_workspace:"kbase"
}]).spread((function(e){"deltaG"in e[0]&&s.push({label:"Delta G",
data:e[0].deltaG+" ("+e[0].deltaGErr+") kcal/mol"})
;for(var a={},i=[],t=0;t<e[0].aliases.length;t++)e[0].aliases[t]in a||(i.push(e[0].aliases[t]),
a[e[0].aliases[t]]=1);return s.push({label:"Aliases",data:i.join(", ")}),s})):s
},this.CompartmentTab=function(e){var a=n.cmphash[e.id];return[{
label:"Compartment",data:a.id},{label:"Name",data:a.name},{label:"pH",data:a.pH
},{label:"potential",data:a.potential}]},this.BiomassTab=function(e){
var a=n.biohash[e.id];return[{label:"Biomass",data:a.id},{label:"Name",
data:a.name},{label:"DNA fraction",data:a.dna},{label:"RNA fraction",data:a.RNA
},{label:"Protein fraction",data:a.protein},{label:"Cell wall fraction",
data:a.cellwall},{label:"Lipid fraction",data:a.lipid},{
label:"Cofactor fraction",data:a.cofactor},{label:"Other fraction",data:a.other
},{label:"Energy mols",data:a.energy},{label:"Equation",data:a.equation}]
},this.setData=function(e){
this.data=e,this.modelreactions=e.modelreactions,this.modelcompounds=e.modelcompounds,
this.modelcompartments=e.modelcompartments,
this.biomasses=e.biomasses,this.gapfillings=e.gapfillings,
this.biochemws="kbase",this.biochem="default";const a=[];this.gfhash={}
;for(let n=0;n<this.gapfillings.length;n++)this.gapfillings[n].simpid="gf."+(n+1),
"fba_ref"in this.gapfillings[n]&&this.gapfillings[n].fba_ref.length>0?a.push({
ref:this.gapfillings[n].fba_ref
}):"gapfill_ref"in this.gapfillings[n]&&this.gapfillings[n].gapfill_ref.length>0&&a.push({
ref:this.gapfillings[n].gapfill_ref
}),this.gfhash[this.gapfillings[n].simpid]=this.gapfillings[n];this.cmphash={}
;for(let d=0;d<this.modelcompartments.length;d++){
const e=this.modelcompartments[d]
;e.cmpkbid=e.compartment_ref.split("/").pop(),"d"===e.cmpkbid&&(this.biochem="plantdefault"),
e.name=n.cmpnamehash[e.cmpkbid],this.cmphash[e.id]=e}this.cpdhash={}
;for(let n=0;n<this.modelcompounds.length;n++){
const e=this.modelcompounds[n],a=e.id.split("_")
;e.dispid=a[0]+"["+a[1]+"]",e.cmpkbid=e.modelcompartment_ref.split("/").pop(),
e.cpdkbid=e.compound_ref.split("/").pop(),
void 0===e.name&&(e.name=e.dispid),e.name=e.name.replace(/_[a-zA-z]\d+$/,""),
this.cpdhash[e.id]=e,
"cpd00000"!==e.cpdkbid&&(this.cpdhash[e.cpdkbid+"_"+e.cmpkbid]=e,
a[0]!==e.cpdkbid&&(e.dispid+="<br>("+e.cpdkbid+")"))}
this.biomasscpds=[],this.biohash={};for(let n=0;n<this.biomasses.length;n++){
const e=this.biomasses[n];this.biohash[e.id]=e,e.dispid=e.id;let a="",t=""
;for(var i=0;i<e.biomasscompounds.length;i++){const n=e.biomasscompounds[i]
;n.id=n.modelcompound_ref.split("/").pop();const s=n.id.split("_")
;n.dispid=s[0]+"["+s[1]+"]";const l=this.cpdhash[n.id]
;if(n.name=l.name,n.formula=l.formula,
n.charge=l.charge,n.cmpkbid=l.cmpkbid,n.biomass=e.id,
this.biomasscpds.push(n),n.coefficient<0){
if(a.length>0&&(a+=" + "),-1!==n.coefficient){
a+="("+Math.round(-100*n.coefficient)/100+") "}
a+=`<a \n                            class="id-click" \n                            data-id="${l.id}"\n                            data-method="CompoundTab">\n                            ${l.name}[${l.cmpkbid}]\n                        </a>`
}else{if(t.length>0&&(t+=" + "),1!==n.coefficient){
t+="("+Math.round(100*n.coefficient)/100+") "}
t+=`<a \n                            class="id-click" \n                            data-id="${l.id}"\n                            data-method="CompoundTab">\n                            ${l.name}[${l.cmpkbid}]\n                        </a>`
}}e.equation=a+'<div style="font-weight: bold;">=></div>'+t}
this.modelgenes=[],this.rxnhash={}
;for(let d=0;d<this.modelreactions.length;d++){var t=this.modelreactions[d]
;const e=t.id.split("_")
;t.dispid=e[0]+"["+e[1]+"]",t.rxnkbid=t.reaction_ref.split("/").pop(),
t.rxnkbid=t.rxnkbid.replace(/_[a-zA-z]/,""),
t.cmpkbid=t.modelcompartment_ref.split("/").pop(),
t.name=t.name.replace(/_[a-zA-z]\d+$/,""),
t.gpr="","CustomReaction"===t.name&&(t.name=t.dispid),
n.rxnhash[t.id]=t,"rxn00000"!==t.rxnkbid&&(this.rxnhash[t.rxnkbid+"_"+t.cmpkbid]=t,
t.rxnkbid!==e[0]&&(t.dispid+="<br>("+t.rxnkbid+")"));let a="<=>"
;">"===t.direction?a="=>":"<"===t.direction&&(a="<="),
t.modelReactionProteins>0&&(t.gpr="");let i="",m=""
;for(let n=0;n<t.modelReactionReagents.length;n++){
const e=t.modelReactionReagents[n]
;e.cpdkbid=e.modelcompound_ref.split("/").pop();const a=this.cpdhash[e.cpdkbid]
;if(e.coefficient<0){if(i.length>0&&(i+=" + "),-1!==e.coefficient){
i+="("+Math.round(-100*e.coefficient)/100+") "}
i+=`<a \n                            class="id-click" \n                            data-id="${a.id}"\n                            data-method="CompoundTab">\n                            ${a.name}[${a.cmpkbid}]\n                        </a>`
}else{if(m.length>0&&(m+=" + "),1!==e.coefficient){
m+="("+Math.round(100*e.coefficient)/100+") "}
m+=`<a \n                            class="id-click" \n                            data-id="${a.id}"\n                            data-method="CompoundTab">\n                            ${a.name}[${a.cmpkbid}]\n                        </a>`
}}t.ftrhash={};for(let n=0;n<t.modelReactionProteins.length;n++){
const e=t.modelReactionProteins[n];n>0&&(t.gpr+=" or "),t.gpr+="("
;for(let a=0;a<e.modelReactionProteinSubunits.length;a++){
const i=e.modelReactionProteinSubunits[a]
;a>0&&(t.gpr+=" and "),t.gpr+="(",0===i.feature_refs.length&&(t.gpr+="Unknown")
;for(let e=0;e<i.feature_refs.length;e++){
const a=i.feature_refs[e].split("/").pop()
;t.ftrhash[a]=1,e>0&&(t.gpr+=" or "),t.gpr+=a}t.gpr+=")"}t.gpr+=")"}
for(var s in t.gapfilling=[],
t.gapfill_data)"<"===t.gapfill_data[s][0][0]?t.gapfilling.push(s+": reverse"):t.gapfilling.push(s+": forward")
;for(var l in t.gapfillingstring=t.gapfilling.join("<br>"),
t.dispfeatures="",t.genes=[],t.ftrhash){t.genes.push({id:l});var o=[]
;this.modelgenes.forEach((function(e){o.push(e.id)
})),-1===o.indexOf(l)?this.modelgenes.push({id:l,reactions:[{id:t.id,
dispid:t.dispid}]}):this.modelgenes[o.indexOf(l)].reactions.push({id:t.id,
dispid:t.dispid})}t.equation=i+'<div style="font-weight: bold;">'+a+"</div>"+m}
a.length>0&&this.workspaceClient.get_objects(a).then((function(e){
for(var a=0;a<e.length;a++)for(var i=e[a].data.gapfillingSolutions[0].gapfillingSolutionReactions,t=0;t<i.length;t++){
var s,l=i[t].reaction_ref.split("/").pop()
;if(l in n.rxnhash)s=n.rxnhash[l];else l=l+"_"+i[t].compartment_ref.split("/").pop()+i[t].compartmentIndex,
s=n.rxnhash[l]
;void 0!==s&&("<"===i[t].direction?s.gapfilling.push("gf."+(a+1)+": reverse"):s.gapfilling.push("gf."+(a+1)+": forward"),
s.gapfillingstring=s.gapfilling.join("<br>"))}})).catch((function(e){
console.error(e)}))}}}));